package betterwithmods.client.container.other;

import betterwithmods.BWMod;
import betterwithmods.common.blocks.tile.TileEntityInfernalEnchanter;
import com.google.common.collect.Maps;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnchantmentNameParts;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by primetoxinz on 9/11/16.
 */
public class GuiInfernalEnchanter extends GuiContainer {
    private FontRenderer fontGalactic;
    private TileEntityInfernalEnchanter tile;
    private ContainerInfernalEnchanter container;
    private EntityPlayer player;

    public GuiInfernalEnchanter(EntityPlayer player, TileEntityInfernalEnchanter tile) {
        super(new ContainerInfernalEnchanter(player, tile));
        this.container = (ContainerInfernalEnchanter) field_147002_h;
        this.player = player;
        this.tile = tile;
        field_147000_g = 211;
    }

    @Override
    public void func_73863_a(int mouseX, int mouseY, float partialTicks) {
        super.func_73863_a(mouseX, mouseY, partialTicks);
        if (fontGalactic == null)
            fontGalactic = this.field_146297_k.field_71464_q;
        this.func_191948_b(mouseX, mouseY);
    }

    @Override
    protected void func_146976_a(float partialTicks, int mouseX, int mouseY) {
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        this.field_146297_k.field_71446_o.func_110577_a(new ResourceLocation(BWMod.MODID, "textures/gui/infernal_enchanter.png"));

        int xPos = (this.field_146294_l - this.field_146999_f) / 2;
        int yPos = (this.field_146295_m - this.field_147000_g) / 2;
        func_73729_b(xPos, yPos, 0, 0, this.field_146999_f, this.field_147000_g);
        if (!field_147002_h.func_75139_a(0).func_75216_d())
            func_73729_b(xPos + 17, yPos + 37, 176, 0, 16, 16);
        if (!field_147002_h.func_75139_a(1).func_75216_d())
            func_73729_b(xPos + 17, yPos + 75, 192, 0, 16, 16);
        EnchantmentNameParts.func_178176_a().func_148335_a((long) this.container.xpSeed);

        int x, y;
        for (int i = 0; i < container.enchantLevels.length; i++) {
            this.field_146297_k.field_71446_o.func_110577_a(new ResourceLocation(BWMod.MODID, "textures/gui/infernal_enchanter.png"));
            GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
            int val = container.enchantLevels[i];
            if (val > 0) {
                String s = String.valueOf(val);
                if (container.hasLevels(player,val)) {
                    y = yPos + 17 + (19 * i);
                    x = xPos + 60;
                    if (mouseX >= x && mouseX <= x + 108 && mouseY >= y && mouseY <= y + 19) {
                        func_73729_b(x, y, 108, 211, 108, 19);
                    } else {
                        func_73729_b(x, y, 0, 211, 108, 19);
                    }
                }
                String s1 = EnchantmentNameParts.func_178176_a().func_148334_a(this.field_146289_q, 86 - this.field_146289_q.func_78256_a(s));
                fontGalactic.func_78279_b(s1, xPos + 62, yPos + 19 + 19 * i, 108, (6839882 & 16711422) >> 1);
                field_146289_q.func_175063_a(s, xPos + field_146999_f - 10 - this.field_146289_q.func_78256_a(s), yPos + 8 + 19 * (i + 1), 0x80FF20);

            }
        }

    }

    private static HashMap<Integer,String> numerals = Maps.newHashMap();
    static {
        numerals.put(22, "I");
        numerals.put(41, "II");
        numerals.put(60, "III");
        numerals.put(79, "IV");
        numerals.put(98, "V");
    }


    @Override
    protected void func_146979_b(int mouseX, int mouseY) {
        String s = I18n.func_135052_a(tile.getName());
        this.field_146289_q.func_78276_b(s, this.field_146999_f / 2 - this.field_146289_q.func_78256_a(s) / 2, 6, 0x404040);
        for (Map.Entry<Integer, String> e : numerals.entrySet()) {
            this.field_146289_q.func_78276_b(e.getValue(), 50 - this.field_146289_q.func_78256_a(e.getValue()) / 2, e.getKey(), 0x404040);
        }
    }

    @Override
    protected void func_73864_a(int mouseX, int mouseY, int mouseButton) throws IOException {
        super.func_73864_a(mouseX, mouseY, mouseButton);
        int xPos = (this.field_146294_l - this.field_146999_f) / 2;
        int yPos = (this.field_146295_m - this.field_147000_g) / 2;

        int x,y;
        for(int i = 0; i < container.enchantLevels.length;i++) {
            if(container.hasLevels(player,container.enchantLevels[i]) && container.bookcaseCount >= container.enchantLevels[i]) {
                y = yPos + 17 + (19 * i);
                x = xPos + 60;
                if (mouseX >= x && mouseX <= x + 108 && mouseY >= y && mouseY <= y + 19) {
                    if(container.func_75140_a(player,i)) {
                        this.field_146297_k.field_71442_b.func_78756_a(this.container.field_75152_c, i);
                    }
                }
            }
        }
    }
}

